
#property copyright "Copyright  2007, Sharptrade Partners LLC."
#property link      "http://FXIMPACT.COM"

#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1 Gainsboro

#import "FXI.dll"
   string gGrab(string a0, string a1);
#import

extern string label = "--Login Information--";
extern string First = "";
extern string Last = "";
extern string EMail = "";
extern string lbl2 = "--Indicator Variables--";
extern double n = 2.0;
double g_ibuf_124[];
double gda_unused_128[1000000];
int gi_132 = 1;
int gi_136 = 0;
int gi_140 = 0;
int gi_144 = 0;
int gi_148 = 0;
int g_bars_152 = 0;
int g_file_156;
bool gi_160 = FALSE;

int init() {
   string ls_0;
   string ls_8;
   string ls_16;
   int l_str2int_24;
   bool li_28;
   int li_32;
   SetIndexStyle(0, DRAW_LINE, EMPTY, 2);
   SetIndexBuffer(0, g_ibuf_124);
   SetLevelValue(0, 0.341);
   SetLevelValue(1, -0.341);
   SetLevelValue(2, 0.0);
   SetLevelStyle(-1, 0, Yellow);
   g_file_156 = FileOpen("fxi.bin", FILE_CSV|FILE_READ);
   if (g_file_156 < 1) {
      ls_0 = First;
      ls_8 = Last;
      ls_16 = EMail;
      li_28 = FALSE;
   } else {
      ls_0 = FileReadString(g_file_156);
      ls_8 = FileReadString(g_file_156);
      ls_16 = FileReadString(g_file_156);
      l_str2int_24 = StrToInteger(FileReadString(g_file_156));
      FileClose(g_file_156);
      li_28 = TRUE;
   }
   Print("localTime : ", l_str2int_24);
   Print("TimeLocal : ", TimeLocal());
   if (TimeLocal() - l_str2int_24 >= 259200 || li_28 == FALSE) {
      li_32 = mylogin(ls_0, ls_8, ls_16);
      switch (li_32) {
      case 0:
         Alert("Logged in");
         g_file_156 = FileOpen("fxi.bin", FILE_WRITE, 8);
         if (g_file_156 < 1) {
            Print("Cannot open password cache!");
            return (0);
         }
         FileWrite(g_file_156, ls_0);
         FileWrite(g_file_156, ls_8);
         FileWrite(g_file_156, ls_16);
         FileWrite(g_file_156, TimeLocal());
         FileClose(g_file_156);
         return (0);
      case 1:
         Alert("Email OK -- Incorrect last name! Please check your name spelling.");
         gi_160 = TRUE;
         if (li_28) FileDelete("fxi.bin");
         break;
      case 2:
         Alert("Email OK -- Incorrect first name! Please check your name spelling.");
         gi_160 = TRUE;
         if (li_28) FileDelete("fxi.bin");
         break;
      case 3:
         Alert("Incorrect EMail for login! Please check your EMail spelling.");
         gi_160 = TRUE;
         if (li_28) FileDelete("fxi.bin");
         break;
      case 4:
         Alert("Your account has been disabled! Please contact support@fximpact.com");
         gi_160 = TRUE;
         if (li_28) FileDelete("fxi.bin");
         break;
      case 5:
         Alert("Server error!! Please make sure you are connected to the Internet and try again.");
         gi_160 = TRUE;
      }
   }
   return (0);
}

int deinit() {
   return (0);
}

int start() {
   if (gi_160 == TRUE) return (0);
   if (Bars > g_bars_152 + 1) gi_148 = FALSE;
   g_bars_152 = Bars;
   gi_144 = IndicatorCounted();
   if (gi_144 < 0) return (-1);
   if (gi_144 > 0) gi_144--;
   if (gi_148 == FALSE) gi_140 = Bars - gi_144 - 2;
   else gi_140 = Bars - gi_144;
   Oscillator();
   return (0);
}

void Oscillator() {
   double ld_0 = 0;
   double ld_8 = 0;
   if (gi_148 == FALSE) {
      for (int l_index_16 = 0; l_index_16 <= gi_140 - 1 - n; l_index_16++) {
         ld_0 = 0;
         ld_8 = 0;
         for (int li_20 = n + l_index_16; li_20 >= l_index_16; li_20--) {
            if (gi_136 == 1 && gi_132 == 0) ld_0 = Close[li_20] - (Close[li_20 + 1]) + ld_0;
            else
               if (gi_136 == 0 && gi_132 == 1) ld_0 = (High[li_20] + Low[li_20]) / 2.0 - (High[li_20 + 1] + (Low[li_20 + 1])) / 2.0 + ld_0;
            ld_8 = High[li_20] - Low[li_20] + ld_8;
         }
         ld_0 /= n;
         ld_8 /= n;
         if (ld_8 > 0.0) g_ibuf_124[l_index_16] = ld_0 / ld_8;
         else g_ibuf_124[l_index_16] = 0;
      }
      gi_148 = TRUE;
      return;
   }
   for (l_index_16 = 0; l_index_16 <= gi_140 - n; l_index_16++) {
      ld_0 = 0;
      ld_8 = 0;
      for (li_20 = n + l_index_16; li_20 >= l_index_16; li_20--) {
         if (gi_136 == 1 && gi_132 == 0) ld_0 = Close[li_20] - (Close[li_20 + 1]) + ld_0;
         else
            if (gi_136 == 0 && gi_132 == 1) ld_0 = (High[li_20] + Low[li_20]) / 2.0 - (High[li_20 + 1] + (Low[li_20 + 1])) / 2.0 + ld_0;
         ld_8 = High[li_20] - Low[li_20] + ld_8;
      }
      ld_0 /= n;
      ld_8 /= n;
      if (ld_8 > 0.0) g_ibuf_124[l_index_16] = ld_0 / ld_8;
      else g_ibuf_124[l_index_16] = 0;
   }
}

int mylogin(string as_0, string as_8, string as_16) {
   
   return (0);
}